#!/bin/bash
#Automatically Created by buildpkg 1.6.1
#Maintainer: tsuren
#url: http://www.fluxbox.org/

######Begin Redundant Code######################################
check_for_root() {
	if [ "$UID" != "0" ]; then
		echo "You need to be root"
		exit 1
	fi
}

clean_dirs () {
        for COMPLETED in src pkg; do
                if [ -e $COMPLETED ]; then
                        rm -rf $COMPLETED
                fi
        done
}

clean_old_builds () {
	for COMPLETED in $package.{tgz,md5,dep}; do
		if [ "$KEEPDEPFILE" = "1" ] && [ $COMPLETED = $package.dep ]; then
			continue
		elif [ -e $COMPLETED ]; then
			rm -rf $COMPLETED
		fi
	done
	clean_dirs
}

set_pre_permissions() {
	cd $startdir/src
	find . -perm 664 -exec chmod 644 {} \;
	find . -perm 600 -exec chmod 644 {} \;
	find . -perm 444 -exec chmod 644 {} \;
	find . -perm 400 -exec chmod 644 {} \;
	find . -perm 440 -exec chmod 644 {} \;
	find . -perm 777 -exec chmod 755 {} \;
	find . -perm 775 -exec chmod 755 {} \;
	find . -perm 511 -exec chmod 755 {} \;
	find . -perm 711 -exec chmod 755 {} \;
	find . -perm 555 -exec chmod 755 {} \;
}


check_for_menu_compliance() {
	if [ -d "$startdir/pkg/usr/share/applications" ]; then
		cd $startdir/pkg/usr/share/applications
		for desktop in *.desktop; do
			Icon=$(grep -e "^Icon=" $desktop | sed 's/Icon=//')
			if [[ "$Icon" ]]; then
				if [ ! "$Icon" == "${Icon%.*}" ]; then
					sed '/Icon/s/\..*$//' -i $desktop
					Icon=$(grep -e "^Icon=" $desktop | sed 's/Icon=//')
				fi
				if [ -d "$startdir/pkg/usr/share/pixmaps" ]; then
					cd $startdir/pkg/usr/share/pixmaps
					for pixmaps in *; do
						[ -d $pixmaps ] && continue
						[ ! "${pixmaps##*.}" == "png" -a ! "${pixmaps##*.}" == "svg" ] && continue
				 		if [ "${pixmaps%.*}" == "$Icon" ]; then
				 			DIR=$(file $pixmaps | awk -F, '{print $2}' | sed 's/ //g')
							[ o"$DIR" == "o" ] && DIR="scalable"
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $pixmaps $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							if [[ ! "$(ls $startdir/pkg/usr/share/pixmaps)" ]]; then
								rm -rf $startdir/pkg/usr/share/pixmaps
							fi
						fi
					done
				fi
				if [ -d "$startdir/pkg/usr/share/icons" ]; then
					cd $startdir/pkg/usr/share/icons
					for icons in *; do
				 		if [ "${icons%.*}" == "$Icon" ]; then
							[ ! "${pixmaps##*.}" == "png" -a ! "${pixmaps##*.}" == "svg" ] && continue
				 			DIR=$(file $icons | awk -F, '{print $2}' | sed 's/ //g')
							[ o"$DIR" == "o" ] && DIR="scalable"
							mkdir -p $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
							mv $icons $startdir/pkg/usr/share/icons/hicolor/$DIR/apps
						fi
					done
				fi
			fi
		done
	fi
}


gzip_man_and_info_pages() {
	for DOCS in man info; do
		if [ -d "$startdir/pkg/usr/share/$DOCS" ]; then
			mv $startdir/pkg/usr/share/$DOCS $startdir/pkg/usr/$DOCS
			if [[ ! "$(ls $startdir/pkg/usr/share)" ]]; then
				rm -rf $startdir/pkg/usr/share
			fi
		fi
		if [ -d "$startdir/pkg/usr/$DOCS" ]; then
			# I've never seen symlinks in info pages....
			if [ "$DOCS" == "man" ]; then
				(cd $startdir/pkg/usr/$DOCS
				for manpagedir in $(find . -type d -name "man*" 2> /dev/null) ; do
					( cd $manpagedir
					for eachpage in $( find . -type l -maxdepth 1 2> /dev/null) ; do
						ln -s $( readlink $eachpage ).gz $eachpage.gz
						rm $eachpage
					done )
				done)
			fi
			find $startdir/pkg/usr/$DOCS -type f -exec gzip -9 '{}' \;
		fi
	done
}

set_post_permissions() {
	for DIRS in usr/share/icons usr/doc; do
		if [ -d "$startdir/pkg/$DIRS" ]; then
			if [ "$DIRS" == "usr/doc" ]; then
				find $startdir/pkg/$DIRS -type f -exec chmod 644 {} \;
				find $startdir/pkg/$DIRS -type d -exec chmod 755 {} \;
			fi
		fi
		[ -d $startdir/pkg/$DIRS ] && chown root:root -R $startdir/pkg/$DIRS
	done
	[ -d $startdir/pkg/usr/bin ] && find $startdir/pkg/usr/bin -user root -group bin -exec chown root:root {} \;
}

copy_build_script() {
	mkdir -p $startdir/pkg/usr/src/$pkgname-$pkgver/
	cp $startdir/build-$pkgname.sh $startdir/pkg/usr/src/$pkgname-$pkgver/build-$pkgname.sh
	[ -f $startdir/ZENBUILD ] && cp $startdir/ZENBUILD $startdir/pkg/usr/src/$pkgname-$pkgver/ZENBUILD
}

create_package() {
	ls -lR $startdir/pkg
	cd $startdir/pkg
	/sbin/makepkg -l y -c n $startdir/$package.tgz
	cd $startdir
	md5sum $package.tgz > $startdir/$package.md5
}

strip_binaries() {
	cd $startdir/pkg
	find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
	find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
	xargs strip --strip-unneeded 2> /dev/null
}
#########End Redundant Code#####################################
#########Begin Non Redundant Code##############################

prepare_directory() {
	mkdir $startdir/src
	mkdir -p $startdir/pkg/usr/src/$pkgname-$pkgver
	for SOURCES in ${source[@]}; do
		protocol=$(echo $SOURCES | sed 's|:.*||')
	        file=$(basename $SOURCES | awk -F= '{print $NF}')
		if [ ! -f "$file" ]; then
			if [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
				echo -e "\nDownloading $(basename $SOURCES)\n"
        	                wget $SOURCES -O $file
				if [ ! "$?" == "0" ]; then
					echo "Download failed"
					exit 2
				fi 
			else
				echo "$SOURCES does not appear to be a url nor is it in the directory"
				exit 2
			fi
		fi
		cp -R $file $startdir/src
		if ! [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
			cp -R $startdir/$(basename $SOURCES) $startdir/pkg/usr/src/$pkgname-$pkgver/
		fi
		if [ "${SOURCES##*.}" == "desktop" ]; then
			[[ "$(grep -e "^Categories=[a-zA-Z]*;" $(basename $SOURCES))" ]] && install -D $startdir/$(basename $SOURCES) /home/tomoki/packages/fluxbox/pkg/usr/share/applications/$(basename $SOURCES)
		fi
	done
}

extract_source() {
	cd $startdir/src
	if [[ "$(ls $startdir/src)" ]]; then	
		for FILES in ${source[@]}; do
	        	FILES="$(basename $FILES | awk -F= '{print $NF}')"
			file_type=$(file -biz "$FILES")
			unset cmd
			case "$file_type" in
				*application/x-tar*)
					cmd="tar -xf" ;;
				*application/x-zip*)
					cmd="unzip" ;;
				*application/x-gzip*)
					cmd="gunzip -d -f" ;;
				*application/x-bzip*)
					cmd="bunzip2 -f" ;;
			esac
			if [ "$cmd" != "" ]; then
				echo "$cmd $FILES"
	        	        $cmd $FILES
			fi
		done
	elif [ ! "$source" ]; then
		echo -n "" # lame fix
	else
		echo "no files in the src directory $startdir/src"
		exit 2
	fi
}

build() {
        cd $startdir/src/$pkgname-$pkgver
		autoreconf -i
		./configure \
  --prefix=/usr \
  --sysconfdir=/etc \
  --infodir=/usr/info \
  --mandir=/usr/man \
  --docdir=/usr/doc/$name-$version \
  --x-includes=/usr/include \
  --x-libraries=/usr/lib \
  --enable-nls \
  --enable-imlib2 \
  --enable-xinerama \
  --with-x
        make || return 1
        make DESTDIR=$startdir/pkg install
		
		# Create The Empty Backgrounds Directory

mkdir -p $startdir/pkg/usr/share/fluxbox/backgrounds
cp $startdir/default.jpg $startdir/pkg/usr/share/fluxbox/backgrounds
cp $startdir/default.jpg $startdir/pkg/usr/src/$pkgname-$pkgver/

# Create the Initialization File

rm -f $startdir/pkg/usr/share/fluxbox/init
cat <<EOF >$startdir/pkg/usr/share/fluxbox/init.new
session.screen0.overlay.lineWidth:	1
session.screen0.overlay.lineStyle:	LineSolid
session.screen0.overlay.joinStyle:	JoinMiter
session.screen0.overlay.capStyle:	CapNotLast
session.screen0.slit.maxOver:	false
session.screen0.slit.direction:	Vertical
session.screen0.slit.layer:	Dock
session.screen0.slit.autoHide:	false
session.screen0.slit.onhead:	1
session.screen0.slit.placement:	BottomRight
session.screen0.slit.alpha:	255
session.screen0.slit.onTop:	False
session.screen0.tab.width:	64
session.screen0.tab.height:	16
session.screen0.tab.rotatevertical:	True
session.screen0.tab.placement:	TopLeft
session.screen0.tab.alignment:	Left
session.screen0.window.focus.alpha:	150
session.screen0.window.unfocus.alpha:	150
session.screen0.tabs.maxOver:	false
session.screen0.tabs.intitlebar:	true
session.screen0.iconbar.mode:	Workspace
session.screen0.iconbar.iconWidth:	48
session.screen0.iconbar.wheelMode:	Screen
session.screen0.iconbar.alignment:	Relative
session.screen0.iconbar.usePixmap:	true
session.screen0.iconbar.iconTextPadding:	10l
session.screen0.toolbar.visible:	true
session.screen0.toolbar.maxOver:	false
session.screen0.toolbar.placement:	TopCenter
session.screen0.toolbar.autoHide:	false
session.screen0.toolbar.tools:	workspacename, prevworkspace, nextworkspace, iconbar, systemtray, prevwindow, nextwindow, clock
session.screen0.toolbar.height:	0
session.screen0.toolbar.layer:	Dock
session.screen0.toolbar.onTop:	False
session.screen0.toolbar.widthPercent:	100
session.screen0.toolbar.alpha:	150
session.screen0.toolbar.onhead:	2
session.screen0.menu.alpha:	120
session.screen0.titlebar.left:	Stick 
session.screen0.titlebar.right:	Minimize Maximize Close 
session.screen0.reversewheeling:	false
session.screen0.colPlacementDirection:	TopToBottom
session.screen0.clickRaises:	true
session.screen0.menuDelay:	0
session.screen0.decorateTransient:	true
session.screen0.resizeMode:	Bottom
session.screen0.strftimeFormat:	\%l:\%M
session.screen0.rowPlacementDirection:	LeftToRight
session.screen0.menuDelayClose:	0
session.screen0.edgeSnapThreshold:	0
session.screen0.defaultDeco:	NORMAL
session.screen0.opaqueMove:	false
session.screen0.focusNewWindows:	true
session.screen0.autoRaise:	true
session.screen0.rootCommand:	fbsetbg -a /usr/share/fluxbox/backgrounds/default.jpg
session.screen0.menuMode:	Delay
session.screen0.showwindowposition:	true
session.screen0.tabFocusModel:	ClickToTabFocus
session.screen0.workspaceNames:	one,two,three,four,
session.screen0.windowScrollAction:	
session.screen0.workspaces:	4
session.screen0.userFollowModel:	Follow
session.screen0.workspacewarping:	true
session.screen0.imageDither:	false
session.screen0.focusLastWindow:	True
session.screen0.fullMaximization:	false
session.screen0.windowMenu:	
session.screen0.windowScrollReverse:	false
session.screen0.focusModel:	ClickFocus
session.screen0.windowPlacement:	RowSmartPlacement
session.screen0.followModel:	Ignore
session.screen0.desktopwheeling:	true
session.tabsAttachArea:	Window
session.appsFile:	~/.fluxbox/apps
session.autoRaiseDelay:	250
session.groupFile:	~/.fluxbox/groups
session.styleFile:	/usr/share/fluxbox/styles/Meta
session.ignoreBorder:	false
session.opaqueMove:	False
session.colorsPerChannel:	4
session.cacheMax:	200l
session.cacheLife:	5l
session.configVersion:	1
session.doubleClickInterval:	250
session.styleOverlay:	~/.fluxbox/overlay
session.forcePseudoTransparency:	true
session.slitlistFile:	~/.fluxbox/slitlist
session.imageDither:	True
session.menuFile:	~/.fluxbox/menu
session.keyFile:	~/.fluxbox/keys
session.tabPadding:	0
session.modKey:	Mod1
EOF
chmod 644 $startdir/pkg/usr/share/fluxbox/init.new

# Create the Menu File

rm -f $startdir/pkg/usr/share/fluxbox/menu
cat <<EOF >$startdir/pkg/usr/share/fluxbox/menu.new
# If you read this it means you want to edit this file manually, so here
# are some useful tips:
#
# - You can add your own menu entries to ~/.fluxbox/usermenu
#
# - The X applications from the official Zenwalk release are included in this menu
#
# - Additional X applications also appear in this menu as comments
#
# - SVG icons are not supported at this time
#
# - To prevent any other app from overwriting your menu
#   you can change the menu name in .fluxbox/init to:
#     session.menuFile: /home/you/.fluxbox/my-menu
[begin] (Zenwalk)
      [separator]
      [exec] (Run Program) {fbrun}
      [workspaces] (Workspace List)
      [separator]
      [exec] (Terminal) {Terminal}
      [exec] (File Manager) {thunar}
      [exec] (Web Browser) {iceweasel}
[submenu] (Accessories)
      [exec] (Character Map) {gucharmap}
	  [exec] (Catfish) {catfish}
      [exec] (Galculator) {galculator}
      [exec] (Mousepad) {mousepad}
      [exec] (Thunar File Manager) {thunar}
      [exec] (Xarchiver) {xarchiver}
      [exec] (Xpad) {xpad}
[end]
[submenu] (Developement)
      [exec] (Bluefish Editor) {bluefish}
      [exec] (Geany) {geany}
      [exec] (Hex Editor) {ghex2}
[end]
#[submenu] (Games)
#      [exec] (AssaultCube) {assaultcube -t}
#      [exec] (FakeNES) {fakenes}
#[end]
[submenu] (Graphics)
      [exec] (Dia Diagram Editor) {dia}
      [exec] (Evince) {evince}
#      [exec] (FontForge) {fontforge}
      [exec] (GQview) {gqview}
#      [exec] (Inkscape SVG Vector Illustrator) {inkscape}
#      [exec] (QCad) {qcad}
      [exec] (The GIMP) {gimp}
[end]
[submenu] (Multimedia)
#      [exec]   (Alsaplayer) {alsaplayer}
#     [exec] (Audacious) {audacious}
      [exec] (G-Mplayer) {gmplayer}
      [exec] (Brasero) {brasero}
      [exec] (Asunder) {asunder}
      [exec] (Mplayer) {mplayer}
      [exec] (Streamtuner) {streamtuner}
#      [exec] (VLC) {vlc}
#      [exec] (x264 Encoder) {x264_gtk_encode}
[end]
[submenu] (Network)
#      [exec]   (aLinkCreator) {alc}
#      [exec]   (Amule) {amule}
#      [exec] (Claws Mail) {claws-mail}
      [exec] (bssh) {bssh}
	  [exec] (bvnc) {bvnc}
      [exec] (Iceweasel) {iceweasel}
      [exec] (FuseSmbTool) {fusesmbtool}
      [exec] (gFTP) {gftp}
#      [exec] (NmapFE) {nmapfe}
      [exec] (Pidgin Internet Messenger) {pidgin}
      [exec] (Icedove) {icedove}
      [exec] (Transmission) {transmission-gtk}
	  [exec] (Wicd) {wicd}
#     [exec] (Urlgfe) {urlgfe}
#     [exec] (Wifi-radar) {gksu wifi-radar}
#      [exec] (Wireshark) {wireshark}
#      [exec] (WxCas) {wxcas}
[end]
[submenu] (Office)
      [exec]   (Abiword) {abiword}
      [exec]   (Calendar) {orage}
      [exec]   (Gnumeric Spreadsheet) {gnumeric}
      [exec]   (Xsane) {xsane}
[end]
[submenu] (Settings)
#      [exec]   (Fluxbox Panel Manager) {fbpanel --configure}
      [config] (Configure Fluxbox)
[submenu] (Fluxbox Styles)
      [stylesdir] (/usr/share/fluxbox/styles)
[end]
[end]
[submenu] (System)
      [exec]   (Bulk Rename) {/usr/libexec/ThunarBulkRename}
      [exec]   (Cups Printing Manager) {iceweasel http://localhost:631/}
#      [exec]   (GParted) {gksu gparted}
      [exec]   (Hibernate) {gksu /usr/sbin/hibernate}
      [exec]   (htop) {Terminal -e htop}
      [exec]   (Login Screen Setup) {gksu gdmsetup}
      [exec]   (NDIS Wireless Drivers) {gksu ndisgtk}
      [exec]   (Netpkg) {gksu xnetpkg}
#      [exec]   (Qemu Launcher) {qemu-launcher}
      [exec]   (Root Terminal) {gksu Terminal}
      [exec]   (Standby) {gksu /usr/sbin/standby}
#      [exec]   (Wine Configurator) {winecfg}
      [exec]   (Zenpanel) {gksu zenpanel}
      [exec]   (Zenwalk Manual) {iceweasel /usr/share/zenmanual/index.html}
[end]
      [separator]
      [exit] (Exit)
[end]
EOF
chmod 644 $startdir/pkg/usr/share/fluxbox/menu.new



# Create the Key-Bindings File

rm -f $startdir/pkg/usr/share/fluxbox/keys
cat <<EOF >$startdir/pkg/usr/share/fluxbox/keys.new
OnDesktop Mouse1 :HideMenus
OnDesktop Mouse2 :WorkspaceMenu
OnDesktop Mouse3 :RootMenu
OnDesktop Mouse4 :NextWorkspace
OnDesktop Mouse5 :PrevWorkspace

Mod1 Tab :NextWindow
Mod1 Shift Tab :PrevWindow
Mod1 F1 :Workspace 1
Mod1 F2 :Workspace 2
Mod1 F3 :Workspace 3
Mod1 F4 :Workspace 4

Control Mod1 s :ExecCommand gksu /usr/sbin/standby
Control Mod1 h :ExecCommand gksu /usr/sbin/hibernate
Control Escape :RootMenu
Control F1 :ExecCommand firefox /usr/share/zenmanual/index.html
Control Mod1 Delete :ExecCommand xscreensaver-command -lock
Control F2 :ExecCommand fbrun
Control Mod1 Escape :ExecCommand xkill
EOF
chmod 644 $startdir/pkg/usr/share/fluxbox/keys.new



# Create Startup Script

rm -f $startdir/pkg/usr/bin/startfluxbox
cat <<EOF00 >$startdir/pkg/usr/bin/startfluxbox
#!/bin/sh
# \$Id: startfluxbox.in 4600 2006-10-27 07:04:51Z mathias \$

command="\`basename \"\$0\"\`"
startup="\$HOME/.fluxbox/startup"

while [ \$# -gt 0 ]; do
    case "\$1" in
        -c|--config)
            if [ \$# -lt 2 ]; then
                echo "\$command:error, missing argument"
                exit 1
            fi
            shift
            startup=\$1
        ;;
        -h|--help) cat <<EOF10
Usage: \$command [-h] [-c startupfile]
EOF10
        exit
        ;;
    esac
    shift
done

if [ -x "\$startup" ]; then
    exec "\$startup"
elif [ -r "\$startup" ]; then
    exec sh "\$startup"
else
    if [ ! -d "\$HOME/.fluxbox" ]; then
        mkdir -p "\$HOME/.fluxbox/backgrounds" "\$HOME/.fluxbox/styles" "\$HOME/.fluxbox/pixmaps"
    fi
    if [ ! -f "\$startup" ]; then
         ( cat << EOF01
# fluxbox startup-script:
#
# Lines starting with a '#' are ignored.

# This shows the fluxbox-splash-screen
#fbsetbg -C /usr/share/fluxbox/splash.jpg

# Other examples. Check man xset for details.

# Turn off beeps:
# xset -b

# Increase the keyboard repeat-rate:
# xset r rate 195 35

# Your own fonts-dir:
# xset +fp "\$HOME/.fonts"

# Your favourite mouse cursor:
# xsetroot -cursor_name right_ptr

# Change your keymap:
# xmodmap "\$HOME/.Xmodmap"
#
# Applications you want to run with fluxbox.
# MAKE SURE THAT APPS THAT KEEP RUNNING HAVE AN ''&'' AT THE END.

xscreensaver -no-splash &
# fbpanel &
# wbar &
# unclutter -idle 2 &
# wmnd &
# wmsmixer -w &
# sleep 2; idesk &
exec fluxbox
EOF01
    ) > "\$startup"
    fi
    chmod 644 "\$startup"
    exec sh \$startup
fi
EOF00
chmod 755 $startdir/pkg/usr/bin/startfluxbox



# Create the New Session File

rm -f $startdir/pkg/etc/X11/dm/Sessions/fluxbox.desktop
mkdir -p $startdir/pkg/etc/X11/dm/Sessions/
cat <<EOF00 >$startdir/pkg/etc/X11/dm/Sessions/fluxbox.desktop
[Desktop Entry]
Encoding=UTF-8
Name=Fluxbox
Comment=The Fluxbox Window Manager
Exec=/etc/X11/xinit/xinitrc.fluxbox
EOF00
chmod 644 $startdir/pkg/etc/X11/dm/Sessions/$name.desktop



# Create the New Initialization File

rm -f $startdir/pkg/etc/X11/xinit/xinitrc.fluxbox
mkdir -p $startdir/pkg/etc/X11/xinit/
cat <<EOF00 >$startdir/pkg/etc/X11/xinit/xinitrc.fluxbox
#!/bin/sh
# \$Xorg: xinitrc.cpp,v 1.3 2000/08/17 19:54:30 cpqbld Exp \$

userresources=\$HOME/.Xresources
usermodmap=\$HOME/.Xmodmap
sysresources=/etc/X11/xinit/.Xresources
sysmodmap=/etc/X11/xinit/.Xmodmap

# merge in defaults and keymaps

if [ -f \$sysresources ]; then
    xrdb -merge \$sysresources
fi

if [ -f \$sysmodmap ]; then
    xmodmap \$sysmodmap
fi

if [ -f \$userresources ]; then
    xrdb -merge \$userresources
fi

if [ -f \$usermodmap ]; then
    xmodmap \$usermodmap
fi

# start some nice programs
startfluxbox 
EOF00
chmod 755 $startdir/pkg/etc/X11/xinit/xinitrc.fluxbox
		
}

create_slackdesc() {
mkdir $startdir/pkg/install
cat <<"EODESC" >$startdir/pkg/install/slack-desc
fluxbox: fluxbox - Highly configurable and low resource X11 Window manager.
fluxbox: 
fluxbox: A fork of Blackbox, Fluxbox has been extended with features such as
fluxbox: pwm-style window tabs, configurable key bindings, an icon bar, and2
fluxbox: the Fluxbox Slit. It also includes some cosmetic fixes over
fluxbox: blackbox, while remaining compatible with all blackbox themes.
fluxbox: 
fluxbox: 
fluxbox: 
fluxbox: 
fluxbox: 
EODESC
}

setup_doinst() {
cat <<"EODOINST" >>$startdir/pkg/install/doinst.sh
doinst() {
	dotnew() {
        NEW="${1}.new"
        OLD="$1"
        if [ ! -e $OLD ]; then
                mv $NEW $OLD
        elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
                rm $NEW
        fi
	}
dotnew usr/share/fluxbox/init
dotnew usr/share/fluxbox/menu
dotnew usr/share/fluxbox/keys
}
doinst
EODOINST
}
copy_docs() {
	for stuff in ${docs[@]}; do
		if [ ! -d "$startdir/pkg/usr/doc/$pkgname-$pkgver" ]; then
			mkdir -p $startdir/pkg/usr/doc/$pkgname-$pkgver
		fi
		find $startdir/src -type f -iname "$stuff" -exec cp -R '{}' $startdir/pkg/usr/doc/$pkgname-$pkgver \;
	done
}
detect_dependencies() {
	echo "Detecting dependencies..."
	depends=$(requiredbuilder -z $startdir/$package.tgz)
	
	depstring=$depends
	unset FIRST
	for deps in $(echo "${depstring}" | sed 's/,/\n/g' | sort -u); do
		if [[ ! "$FIRST" ]]; then
			finaldeps=$deps,
			FIRST='1'
			continue
		fi
		finaldeps=${finaldeps}${deps},
	done
	echo "$finaldeps" | sed -e 's/^,//' -e 's/,$//' > $startdir/$package.dep
}
create_source_file(){
	[ -f $package.src ] && rm $package.src
	if [ ! -z $sourcetemplate ]; then
		echo $sourcetemplate/ZENBUILD >> $package.src
		echo $sourcetemplate/build-$pkgname.sh >> $package.src
	else
		echo ZENBUILD >> $package.src
		echo build-$pkgname.sh >> $package.src
	fi
	for SOURCES in ${source[@]}; do
		protocol=$(echo $SOURCES | sed 's|:.*||')
		if ! [ "$protocol" = "http" -o "$protocol" = "https" -o "$protocol" = "ftp" ]; then
			if [ ! -z $sourcetemplate ]; then
				echo $sourcetemplate/$(basename $SOURCES) >> $package.src
			else
				echo $(basename $SOURCES) >> $package.src
			fi
		else
			echo $SOURCES >> $package.src
		fi
	done
}
post_checks(){
	# Ideas taken from src2pkg :)
	if [ -d "$startdir/pkg/usr/doc/$pkgname-$pkgver" ]; then
		for DIRS in usr/doc/$pkgname-$pkgver usr/doc; do
			cd $startdir/pkg/$DIRS
			if [[ $(find . -type f) = "" ]] ; then
				cd ..
				rmdir $DIRS
			fi
		done
	fi
	# if the docs weren't deleted ...
	if [ -d "$startdir/pkg/usr/doc/$pkgname-$pkgver" ]; then
		cd $startdir/pkg/usr/doc/$pkgname-$pkgver
		#remove zero lenght files
		if [[ $(find . -type f -size 0) ]]; then
			echo "Removing some zero lenght files"
			find . -type f -size 0 -exec rm -f {} \;
		fi
	fi
	# check if we need to add code to handle info pages
	if [[ -d $startdir/pkg/usr/info ]] && [[ ! $(grep install-info $startdir/pkg/install/doinst.sh &> /dev/null) ]] ; then
		echo "Found info files - Adding install-info command to doinst.sh"
		INFO_LIST=$(ls -1 $startdir/pkg/usr/info)
		echo "" >> $startdir/pkg/install/doinst.sh
		echo "if [ -x usr/bin/install-info ] ; then" >> $startdir/pkg/install/doinst.sh
		for page in $(echo $INFO_LIST) ; do
			echo " usr/bin/install-info --info-dir=usr/info usr/info/$page 2>/dev/null" >> $startdir/pkg/install/doinst.sh
		done
		echo "fi" >> $startdir/pkg/install/doinst.sh
	fi
	[[ -e $startdir/pkg/usr/info/dir ]] && rm -f $startdir/pkg/usr/info/dir

	if [ -d $startdir/pkg/etc ]; then
		cd $startdir/pkg/
		for conf in $(find ./etc -type f) ; do
			conf=${conf: 2}
			dotnew=( "${dotnew[@]}" "$conf" )
		done
	fi
	if [[ "$dotnew" ]]; then
        for files in ${dotnew[@]} ; do
                fullfile="${startdir}/pkg/${files}"
                if [ -e "$fullfile" ]; then
                        mv $fullfile ${fullfile}.new
                else
                        echo "$fullfile was not found"
                        exit 2
                fi
        done
        cat<<"EODOTNEW" >>$startdir/pkg/install/doinst.sh
#Added by buildpkg 1.6.1
dotnew() {
        NEW="${1}.new"
        OLD="$1"
        if [ ! -e $OLD ]; then
                mv $NEW $OLD
        elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
                rm $NEW
        fi
}
EODOTNEW
for i in ${dotnew[@]}; do
echo "dotnew $i" >> $startdir/pkg/install/doinst.sh
done
fi
}

####End Non Redundant Code############################

#Variables

startdir=$(pwd)
SRC=$startdir/src
PKG=$startdir/pkg

pkgname=fluxbox
pkgver=1.1.1
pkgrel=1
zenver=54
arch=i486
package=$pkgname-$pkgver-$arch-$zenver.$pkgrel
source=("http://prdownloads.sourceforge.net/fluxbox/fluxbox-1.1.1.tar.gz")
sourcetemplate=http://zenwalk.pinguix.com/user-accounts/tsuren/xap/fluxbox
docs=(AUTHORS ChangeLog COPY INSTALL NEWS LICENSE notes README TODO)
export CFLAGS="-O2 -march=i486 -mtune=i686"
export CXXFLAGS="-O2 -march=i486 -mtune=i686"

#Execution

check_for_root
clean_old_builds
prepare_directory
extract_source
set_pre_permissions
build
if [ ! "$?" = "0" ]; then
	echo "build() failed."
	exit 2
fi
create_slackdesc
post_checks
setup_doinst
copy_docs
check_for_menu_compliance
strip_binaries
gzip_man_and_info_pages
set_post_permissions
copy_build_script
create_package
create_source_file
detect_dependencies
echo "Package has been built."
echo "Cleaning pkg and src directories"
clean_dirs
